import { jsx as t, jsxs as P, Fragment as E } from "react/jsx-runtime";
import { useEffect as A, useMemo as N, Fragment as D } from "react";
import { a as I } from "../../../useQuery-n4ls1rLk.js";
import { a as k } from "../../../axios-f2q_J-wz.js";
import { cn as _ } from "../../../utils/functions.js";
import { RenderEach as u } from "../../../utils/components/RenderEach.js";
import { RenderIf as S } from "../../../utils/components/RenderIf.js";
import { useTableContext as d } from "../context/index.js";
import { useTableInfoRest as F } from "../utils/useTableInfoRest.js";
import { TableTd as C } from "./Elements.js";
import { FiltersBox as O } from "./Filters.js";
import { TableLoading as j, TableErrorData as M, TableEmptyData as q } from "./TableStatesComponents.js";
import { WrapperTableTdComponents as L } from "./TdComponents/WrapperTableTdComponents.js";
import { TableTheadVariants as R, TableThItem as U } from "./variants.js";
const $ = ({ thead: e, isLastTh: s }) => {
  const c = e.cellType == "longText";
  if (e != null && e.thComponent) {
    const { componentKey: a, ...n } = e.thComponent, i = Object.assign({}, { ...n, thead: e, cellparam: e.cellParam, componentKey: a });
    return /* @__PURE__ */ P(
      "th",
      {
        style: e.thStyles,
        className: _(
          "_text-start _whitespace-nowrap _p-0 _sticky _top-0",
          { "_w-96": c },
          e.isAction ? "_w-5 _min-w-[50px]" : "_min-w-[100px]",
          e.thClassName
        ),
        children: [
          " ",
          /* @__PURE__ */ t(L, { ...i }),
          " "
        ]
      }
    );
  }
  return /* @__PURE__ */ t(
    "th",
    {
      style: e.thStyles,
      className: _(
        "_text-start _whitespace-nowrap _p-0 _sticky _top-0",
        { "_w-96": c },
        e.isAction ? "_w-5 _min-w-[50px]" : "_min-w-[100px]",
        e.thClassName
      ),
      children: /* @__PURE__ */ P("div", { className: _(U({ variant: "govco" }), "_flex _justify-between _items-center"), children: [
        /* @__PURE__ */ t("p", { children: e.columnName }),
        /* @__PURE__ */ t(S, { condition: !!(e.filter || e.canSort), children: /* @__PURE__ */ t(O, { isLastTh: s, thead: e }) })
      ] })
    }
  );
}, oe = ({ tableConfig: e }) => /* @__PURE__ */ t("thead", { className: _(R({ variant: "govco" }), "_sticky _top-0 _z-[1] _border-none"), children: /* @__PURE__ */ t("tr", { className: "_sticky _top-0 _z-10 _bg-primary/10 _border _border-b-primary", children: /* @__PURE__ */ t(
  u,
  {
    of: e,
    render: (s, c) => /* @__PURE__ */ t($, { isLastTh: e.length - 1 == c, thead: s }, s.cellParam)
  }
) }) }), se = ({ tableConfig: e, data: s, url: c, headers: a }) => {
  const [n] = d((l) => l.setterDataConfig), [i] = d((l) => l[(n == null ? void 0 : n.targetDataId) ?? "checkedData"]);
  return A(() => {
    i && (n == null || n.setterFn(i));
  }, [i]), c ? /* @__PURE__ */ t(B, { tableConfig: e, url: c, headers: a }) : /* @__PURE__ */ t("tbody", { className: "_relative", children: /* @__PURE__ */ t(W, { data: s, tableConfig: e }) });
}, B = ({ tableConfig: e, url: s, headers: c }) => {
  var f;
  const [a, n] = d((r) => r.metaDataPagination), [i] = d((r) => r.mutateDataConfig), { queryParams: l } = F(), { data: m, isError: T, isPending: h } = I({
    queryKey: ["tbodyWithUrl", s, `${a == null ? void 0 : a.currentPage}`, l],
    queryFn: async () => {
      const r = l, o = k.create({
        headers: {
          "Content-Type": "application/json",
          "Access-Control-Allow-Origin": "*",
          "Access-Control-Allow-Methods": "GET, POST, PUT, DELETE, OPTIONS",
          "Access-Control-Allow-Credentials": !0,
          "Access-Control-Allow-Headers": "*",
          ...c
        }
      }), { data: p } = await o.get(r).then((g) => g);
      return p;
    },
    select: (r) => {
      if (!i)
        return r;
      if (i.targetIdProperty) {
        const o = r[i.targetIdProperty];
        return { items: o == null ? void 0 : o.map((g, y, b) => ({
          ...g,
          [i.newPropertyName]: `${b[y][i.targetItems[0]]}#${b[y][i.targetItems[1]]}`
        })), meta: r.meta };
      }
    }
  });
  return A(() => {
    m && n((r) => {
      r.metaDataPagination = m.meta;
    });
  }, [m]), h ? /* @__PURE__ */ t(j, {}) : T ? /* @__PURE__ */ t(M, {}) : !m || (((f = m.items) == null ? void 0 : f.length) ?? 0) == 0 ? /* @__PURE__ */ t(q, {}) : /* @__PURE__ */ t("tbody", { className: "_relative", children: /* @__PURE__ */ t(
    u,
    {
      of: m.items,
      render: (r, o) => /* @__PURE__ */ t("tr", { className: "_border-b _border-slate-100", children: /* @__PURE__ */ t(u, { of: e, render: (p) => /* @__PURE__ */ t(C, { data: r, dataConfig: p }, p.cellParam) }) }, o)
    }
  ) });
}, W = ({ tableConfig: e, data: s }) => /* @__PURE__ */ t(
  u,
  {
    of: s,
    render: (c, a) => /* @__PURE__ */ t("tr", { className: "_border-b _border-slate-100", children: /* @__PURE__ */ t(u, { of: e, render: (n) => /* @__PURE__ */ t(C, { data: c, dataConfig: n }, n.cellParam) }) }, a)
  }
), ie = () => {
  const [e, s] = d((r) => r.metaDataPagination), c = N(() => Array.from({ length: (e == null ? void 0 : e.totalPages) ?? 1 }, (r, o) => o + 1), [e == null ? void 0 : e.totalPages]), a = (e == null ? void 0 : e.currentPage) ?? 1, n = (e == null ? void 0 : e.totalPages) ?? 1, i = a == 1, l = a == n, m = (r) => {
    s((o) => {
      o.metaDataPagination && (o.metaDataPagination.currentPage = r);
    });
  }, T = () => {
    i || s((r) => {
      r.metaDataPagination && (r.metaDataPagination.currentPage = a - 1);
    });
  }, h = () => {
    l || s((r) => {
      r.metaDataPagination && (r.metaDataPagination.currentPage = a + 1);
    });
  }, f = N(() => {
    if (n < 2)
      return [1];
    const r = a > 3 ? [1, "..."] : [1, 2], o = n == 0 ? [] : [n], p = a < n - 2 ? ["...", n] : o, g = Math.max(1, a - 1), y = Math.min(a + 1, n), b = c.slice(g - 1, y), x = [...r, ...b, ...p];
    return x.filter((w, v) => x.indexOf(w) === v || w === "...");
  }, [e]);
  return /* @__PURE__ */ P("div", { className: "_flex _gap-1 _w-min _px-2 _py-1 _mt-2 _rounded-md", children: [
    /* @__PURE__ */ t("span", { onClick: T, className: _("_underline _cursor-pointer _text-primary _select-none", { "_text-gray-300": i }), children: "Anterior" }),
    /* @__PURE__ */ t("div", { className: "_flex _justify-center _items-center _gap-1 _w-56", children: /* @__PURE__ */ t(
      u,
      {
        of: f,
        render: (r, o) => /* @__PURE__ */ t(D, { children: r === "..." ? /* @__PURE__ */ t("span", { className: "_cursor-default", children: "..." }, o) : /* @__PURE__ */ t(
          "p",
          {
            className: _("_py-0.5 _px-2.5 _rounded-full _cursor-pointer hover:_bg-primary/80 hover:_text-white", {
              "_bg-primary _text-white": a == r
            }),
            onClick: () => {
              m(+r);
            },
            children: r
          },
          o
        ) }, o)
      }
    ) }),
    /* @__PURE__ */ t("span", { onClick: h, className: _("_underline _cursor-pointer _text-primary _select-none", { "_text-gray-300": l }), children: "Siguiente" })
  ] });
}, ce = () => {
  const [e] = d((s) => s.pagination);
  return /* @__PURE__ */ t(E, { children: /* @__PURE__ */ t("div", { className: "_w-full", children: JSON.stringify(e) }) });
};
export {
  ie as TablePagination,
  se as TableTbody,
  ce as TableTest,
  oe as TableThead
};
